#include "stdtag.h"
#include <string.h>
#include <stdlib.h>

struct menudescr
{
    char * submenus[10];
    int selectabilities[10];
} md;

void q_menutag_tp(struct tgml_taginfo *ti)
{
    if(strccmp(ti->tag_name,"menu") && ti->negative)
    {
	jprintf("return(menu[0]);\n");
	td.tagparser = NULL;
	td.recursion_level --;
	jprintf("}\n");
	return;
    }

    
    if(strccmp(ti->tag_name,"item"))
    {
	char * selectable , *name, st = -1;
	
	if(ti->negative) fatal("PARSE ERROR: </item> not allowed\n");

	selectable = tgml_lookup(ti,"selectable");
	name = tgml_lookup(ti,"name");
	
	if(selectable)
	{
	    if(strccmp(selectable, "no")) st = 1;
	    if(strccmp(selectable, "yes")) st = 0;
	}
	else
	    st = 0;
	
	if(st == -1) fatal("PARSE ERROR: 'selectable' in <item> in <menu> can be only 'yes' or 'no'\n");
	if(! name) fatal("PARSE ERROR: <item> inside <menu> requires 'name'\n");
	
	jprintf("tgt_menu_add(menu[%d], \"%s\", %d, NULL);\n", td.internal, name, st);
    }
    if(strccmp(ti->tag_name,"div"))
    {
	if(ti->negative) fatal("PARSE ERROR: </div> not allowed\n");
	jprintf("tgt_menu_add(menu[%d], NULL, 0, NULL);\n",td.internal);
    }
    if(strccmp(ti->tag_name,"submenu"))
    {
	if(! ti->negative)
	{
	    char * selectable , *name, * cb, st = -1;

	    if((++td.internal) > 9) fatal("Too deep menu (max 10 levels of depth)\n");
	    jprintf("menu[%d] = tgt_menu_getcontext();\n", td.internal);
	
	    selectable = tgml_lookup(ti,"selectable");
	    name = tgml_lookup(ti,"name");
	    cb = tgml_lookup(ti,"callback");
	
	    if(cb)
		jprintf("tgt_set(menu[%d],TGTT_CALLBACK, %s);\n", td.internal, cb);
	    
	
	    if(selectable)
	    {
		if(strccmp(selectable, "no")) st = 1;
		if(strccmp(selectable, "yes")) st = 0;
	    }
	    else
		st = 0;
	
	    if(st == -1) fatal("PARSE ERROR: 'selectable' in <submenu> can be only 'yes' or 'no'\n");
	    if(! name) fatal("PARSE ERROR: <submenu> requires 'name'\n");
	    md.submenus[td.internal] = strdup(name);
	    md.selectabilities[td.internal] = st;
	}
	else
	{
	    jprintf("tgt_menu_add(menu[%d], \"%s\", %d,menu[%d]);\n",td.internal-1, md.submenus[td.internal], md.selectabilities[td.internal], td.internal);
	    free(md.submenus[td.internal]);
	    if((--td.internal) < 0) fatal("PARSE ERROR: Unbalanced <submenu> .. </submenu> tags\n");
	}
    }
}


void p_menutag(struct tgml_taginfo * ti)
{
    char * name, * cb;
    
    if(ti->negative) 
	fatal("PARSE ERROR: </menu> can not be used in that context\n");
    if(td.recursion_level != 0)
	fatal("PARSE ERROR: it's possible to use <menu> tag only outside windows\n");
	
    name = tgml_lookup(ti, "name");
    cb = tgml_lookup(ti,"callback");
	
    if(! name)
        fatal("PARSE ERROR: name parameter is compulsory for <menu> tag\n");

    jprintf("struct tgt_object * create_%s(void)\n",name);
    jprintf("{\n");
    
    td.recursion_level ++;
    td.first_window = 0;

    jprintf("struct tgt_object * menu[10];\n");
    jprintf("menu[0] = tgt_menu_getcontext();\n");
    if(cb)
	jprintf("tgt_set(menu[0],TGTT_CALLBACK, %s);\n", cb);

    td.tagparser = q_menutag_tp;
    td.internal = 0;
}


