#include "stdtag.h"
#include <string.h>
#include <stdlib.h>

#define MAX_RECURSION 256

unsigned char wininnerspacing = 0;
long winid = 0;

void p_wintag(struct tgml_taginfo * ti)
{
    if(ti->negative)
    {
	td.parsing_window = 0;
	if(wininnerspacing)
	    jprintf("TGT_AC_SPACE, %d,\n",wininnerspacing);
	
	jprintf("TGTT_END, 0});\n");
	if(winid) jprintf("tgt_set(win, TGTT_ID, %d);",winid);
	jprintf("return(win);\n");
	td.recursion_level --;
	jprintf("}\n");
	if(td.recursion_level != 0)
	    fatal("PARSE ERROR: Unbalanced tags inside <window> ... </window>\n");
	
    }
    else
    {
	char * name, *title, *align;
	char * is, *id;

	if(td.parsing_window)
	    fatal("PARSE ERROR: Unclosed <window> tag\n");
	td.parsing_window = 1;
	
	title = tgml_lookup(ti, "title");
	name = tgml_lookup(ti, "name");
	align = tgml_lookup(ti, "align");
	is = tgml_lookup(ti, "innerspacing");
	id = tgml_lookup(ti, "id");
	if(id)
	    winid = atoi(id);
	else
	    winid = 0;
	    
	if(is)
	    wininnerspacing = atoi(is);
	else
	    wininnerspacing = 0;
	
	if((! title) || (! name))
	    fatal("PARSE ERROR: title & name parameters are compulsory for <window> tag\n");

	if(index(name,' ')||index(name,'\t')||index(name,'\n'))
	    fatal("PARSE ERROR: forbidden characters in window name\n");

	jprintf("struct tgt_object * create_%s(void)\n",name);
	jprintf("{\n");
	td.recursion_level ++;
	td.first_window = 0;
	jprintf("struct tgt_object * win;\n");
	jprintf("win = tgt_ac_mkwindow(\"%s\", %s, (tgtt[]) {", title, align?align2const(align):"0");
	if(wininnerspacing)
	    jprintf("TGT_AC_SPACE, %d,\n",wininnerspacing);
	
    }
}
